Botan: Botan::Hex_Encoder Class Reference

Botan 1.10.16

Public Types | Public Member Functions | Protected Member Functions | List of all members
Botan::Hex_Encoder Class Reference

`#include <hex_filt.h>`

Inheritance diagram for Botan::Hex_Encoder:

## Public Types
enum | Case { Uppercase, Lowercase }

## Public Member Functions
virtual bool | attachable ()
void | end_msg ()
| Hex_Encoder (Case the_case)
| Hex_Encoder (bool newlines=false, size_t line_length=72, Case the_case=Uppercase)
std::string | name () const
virtual void | start_msg ()
void | write (const byte in[], size_t length)

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Detailed Description

Converts arbitrary binary data to hex strings, optionally with newlines inserted

Definition at line 19 of file hex_filt.h.

## Member Enumeration Documentation

## ◆ Case

enum Botan::Hex_Encoder::Case

Whether to use uppercase or lowercase letters for the encoded string.

Enumerator
Uppercase |
Lowercase |

Definition at line 25 of file hex_filt.h.

25 { Uppercase, Lowercase };
Botan::Hex_Encoder::Uppercase
Definition: hex_filt.h:25
Botan::Hex_Encoder::Lowercase
Definition: hex_filt.h:25

## Constructor & Destructor Documentation

## ◆ Hex_Encoder() [1/2]

Botan::Hex_Encoder::Hex_Encoder | ( | Case | the_case | ) |

Create a hex encoder.

Parameters

  the_case | the case to use in the encoded strings.

Definition at line 36 of file hex_filt.cpp.

References Botan::hex_encode(), Botan::CT::min(), Botan::MemoryRegion< T >::resize(), Botan::Filter::send(), Botan::MemoryRegion< T >::size(), and Uppercase.

36 : casing(c), line_length(0)
37 {
38 in.resize(HEX_CODEC_BUFFER_SIZE);
39 out.resize(2*in.size());
40 counter = position = 0;
41 }
Botan::MemoryRegion::resize
void resize(size_t n)
Definition: secmem.h:211
Botan::HEX_CODEC_BUFFER_SIZE
const size_t HEX_CODEC_BUFFER_SIZE
Definition: hex_filt.cpp:20
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ Hex_Encoder() [2/2]

Botan::Hex_Encoder::Hex_Encoder | ( | bool | newlines = `false`,
|  | size_t | line_length = `72`,
|  | Case | the_case = `Uppercase`
| ) |  |

Create a hex encoder.

Parameters

  newlines | should newlines be used
  line_length | if newlines are used, how long are lines
  the_case | the case to use in the encoded strings

Definition at line 25 of file hex_filt.cpp.

References Botan::MemoryRegion< T >::resize(), and Botan::MemoryRegion< T >::size().

25 :
26 casing(c), line_length(breaks ? length : 0)
27 {
28 in.resize(HEX_CODEC_BUFFER_SIZE);
29 out.resize(2*in.size());
30 counter = position = 0;
31 }
Botan::MemoryRegion::resize
void resize(size_t n)
Definition: secmem.h:211
Botan::HEX_CODEC_BUFFER_SIZE
const size_t HEX_CODEC_BUFFER_SIZE
Definition: hex_filt.cpp:20
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inlinevirtualinherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

## ◆ end_msg()

void Botan::Hex_Encoder::end_msg | ( |  | ) |
| virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 99 of file hex_filt.cpp.

References Botan::Filter::send().

100 {
101 encode_and_send(&in[0], position);
102 if(counter && line_length)
103 send('\n');
104 counter = position = 0;
105 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ name()

std::string Botan::Hex_Encoder::name | ( |  | ) | const
| inlinevirtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 27 of file hex_filt.h.

27 { return "Hex_Encoder"; }

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::Filter::end_msg(), Botan::MemoryRegion< T >::size(), Botan::Filter::start_msg(), and Botan::Filter::write().

Referenced by Botan::Base64_Encoder::Base64_Encoder(), Botan::EAX_Decryption::EAX_Decryption(), Botan::PK_Encryptor_Filter::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::PBE_PKCS5v15::end_msg(), end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PBE_PKCS5v20::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Hex_Encoder(), Botan::ECB_Encryption::name(), Botan::EAX_Base::name(), Botan::ECB_Decryption::name(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), Botan::CTS_Decryption::set_iv(), Botan::CBC_Decryption::set_iv(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Bzip_Compression::write(), Botan::Zlib_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:152
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inlinevirtualinherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

Referenced by Botan::Filter::send().

38 {}

## ◆ write()

void Botan::Hex_Encoder::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 76 of file hex_filt.cpp.

References Botan::MemoryRegion< T >::copy(), and Botan::MemoryRegion< T >::size().

77 {
78 in.copy(position, input, length);
79 if(position + length >= in.size())
80 {
81 encode_and_send(&in[0], in.size());
82 input += (in.size() - position);
83 length -= (in.size() - position);
84 while(length >= in.size())
85 {
86 encode_and_send(input, in.size());
87 input += in.size();
88 length -= in.size();
89 }
90 in.copy(input, length);
91 position = 0;
92 }
93 position += length;
94 }
Botan::MemoryRegion::copy
void copy(const T in[], size_t n)
Definition: secmem.h:120
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

The documentation for this class was generated from the following files:

- src/filters/codec_filt/hex_filt.h
- src/filters/codec_filt/hex_filt.cpp